package org.jeecg.modules.system.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.jeecg.modules.system.entity.ItdmPersonManageTask;

import java.util.Date;
import java.util.List;

public interface ItdmPersonManageTaskMapper extends BaseMapper<ItdmPersonManageTask> {

    /**
     * 新增一条人员管理
     */
    @Select("insert into itdm_person_manage set id=#{id}, name = #{name}, sex = #{sex}, tel = #{tel}, position = #{position}, user_id = #{userId}, create_time = #{createTime}" )
    void insertIntoPersonManage(@Param("id") String id,
                               @Param("name") String name,
                               @Param("sex") Integer sex,
                               @Param("tel") String tel,
                               @Param("position") String position,
                               @Param("userId") String userId,
                               @Param("createTime") Date createTime);

    /**
     * 修改对应的人员管理
     */
    @Select("update itdm_person_manage set name = #{name}, sex = #{sex}, tel = #{tel}, position = #{position}, update_time = #{updateTime} where user_id = #{userId}" )
    void updatePersonManage(@Param("name") String name,
                            @Param("sex") Integer sex,
                            @Param("tel") String tel,
                            @Param("position") String position,
                            @Param("userId") String userId,
                            @Param("updateTime") Date updateTime);
}
